From fe4a886ec4a8e4f6c06096ef8a2f2d0e1e47a818 Mon Sep 17 00:00:00 2001
From: Takashi Kato <tohosaku@users.osdn.me>
Date: Tue, 7 May 2024 22:29:58 +0000
Subject: [PATCH] Convert jstoolbar to ES Module

---
 .../javascripts/jstoolbar/common_mark.js      | 244 --------
 app/assets/javascripts/jstoolbar/jstoolbar.js | 568 ------------------
 .../jstoolbar/lang/jstoolbar-ar.js            |  20 -
 .../jstoolbar/lang/jstoolbar-az.js            |  20 -
 .../jstoolbar/lang/jstoolbar-bg.js            |  20 -
 .../jstoolbar/lang/jstoolbar-bs.js            |  18 -
 .../jstoolbar/lang/jstoolbar-ca.js            |  20 -
 .../jstoolbar/lang/jstoolbar-cs.js            |  20 -
 .../jstoolbar/lang/jstoolbar-da.js            |  20 -
 .../jstoolbar/lang/jstoolbar-de.js            |  20 -
 .../jstoolbar/lang/jstoolbar-en-gb.js         |  20 -
 .../jstoolbar/lang/jstoolbar-en.js            |  20 -
 .../jstoolbar/lang/jstoolbar-es-pa.js         |  20 -
 .../jstoolbar/lang/jstoolbar-es.js            |  20 -
 .../jstoolbar/lang/jstoolbar-et.js            |  37 --
 .../jstoolbar/lang/jstoolbar-eu.js            |  24 -
 .../jstoolbar/lang/jstoolbar-fa.js            |  20 -
 .../jstoolbar/lang/jstoolbar-fi.js            |  20 -
 .../jstoolbar/lang/jstoolbar-fr.js            |  20 -
 .../jstoolbar/lang/jstoolbar-gl.js            |  20 -
 .../jstoolbar/lang/jstoolbar-he.js            |  20 -
 .../jstoolbar/lang/jstoolbar-hr.js            |  20 -
 .../jstoolbar/lang/jstoolbar-hu.js            |  20 -
 .../jstoolbar/lang/jstoolbar-id.js            |  20 -
 .../jstoolbar/lang/jstoolbar-it.js            |  23 -
 .../jstoolbar/lang/jstoolbar-ja.js            |  20 -
 .../jstoolbar/lang/jstoolbar-ko.js            |  20 -
 .../jstoolbar/lang/jstoolbar-lt.js            |  20 -
 .../jstoolbar/lang/jstoolbar-lv.js            |  21 -
 .../jstoolbar/lang/jstoolbar-mk.js            |  20 -
 .../jstoolbar/lang/jstoolbar-mn.js            |  20 -
 .../jstoolbar/lang/jstoolbar-nl.js            |  20 -
 .../jstoolbar/lang/jstoolbar-no.js            |  20 -
 .../jstoolbar/lang/jstoolbar-pl.js            |  21 -
 .../jstoolbar/lang/jstoolbar-pt.js            |  21 -
 .../jstoolbar/lang/jstoolbar-ro.js            |  20 -
 .../jstoolbar/lang/jstoolbar-ru.js            |  20 -
 .../jstoolbar/lang/jstoolbar-sk.js            |  20 -
 .../jstoolbar/lang/jstoolbar-sl.js            |  20 -
 .../jstoolbar/lang/jstoolbar-sq.js            |  20 -
 .../jstoolbar/lang/jstoolbar-sr-yu.js         |  20 -
 .../jstoolbar/lang/jstoolbar-sr.js            |  20 -
 .../jstoolbar/lang/jstoolbar-sv.js            |  20 -
 .../jstoolbar/lang/jstoolbar-ta-in.js         |  20 -
 .../jstoolbar/lang/jstoolbar-th.js            |  20 -
 .../jstoolbar/lang/jstoolbar-tr.js            |  18 -
 .../jstoolbar/lang/jstoolbar-uk.js            |  20 -
 .../jstoolbar/lang/jstoolbar-vi.js            |  20 -
 .../jstoolbar/lang/jstoolbar-zh-tw.js         |  20 -
 .../jstoolbar/lang/jstoolbar-zh.js            |  20 -
 app/assets/javascripts/jstoolbar/textile.js   | 229 -------
 app/assets/stylesheets/jstoolbar.css          |  38 ++
 app/helpers/application_helper.rb             |  55 +-
 app/helpers/custom_fields_helper.rb           |  14 +-
 .../controllers/list_autofill_controller.js   | 124 ----
 .../controllers/precode_controller.js         |  52 ++
 .../controllers/table_generator_controller.js |  41 ++
 .../controllers/template_controller.js        |  18 +
 .../controllers/texteditor_controller.js      |  84 +++
 app/javascript/helper.js                      |  17 +
 app/javascript/jstoolbar.js                   | 550 +++++++++++++++++
 .../jstoolbar/formatting/common_mark.js       | 276 +++++++++
 .../jstoolbar/formatting/textile.js           | 236 ++++++++
 app/views/common/_code_highlighting.html.erb  |  12 +
 app/views/common/_table_generator.html.erb    |  14 +
 app/views/common/_texteditor.html.erb         |  17 +
 app/views/documents/_form.html.erb            |   8 +-
 app/views/issues/_edit.html.erb               |  13 +-
 app/views/issues/_form.html.erb               |  19 +-
 app/views/issues/_form_custom_fields.html.erb |   8 +-
 app/views/issues/bulk_edit.html.erb           |  10 +-
 app/views/journals/_notes_form.html.erb       |   7 +-
 app/views/messages/_form.html.erb             |   7 +-
 app/views/news/_form.html.erb                 |   8 +-
 app/views/news/show.html.erb                  |   9 +-
 app/views/projects/_form.html.erb             |   4 +-
 app/views/search/index.html.erb               |   2 +-
 app/views/settings/_general.html.erb          |   4 +-
 app/views/settings/_notifications.html.erb    |   6 +-
 app/views/timelog/_form.html.erb              |   6 +-
 app/views/timelog/bulk_edit.html.erb          |   4 +-
 app/views/wiki/edit.html.erb                  |   7 +-
 config/importmap.rb                           |   4 +
 config/locales/ar.yml                         |  20 +
 config/locales/az.yml                         |  20 +
 config/locales/bg.yml                         |  20 +
 config/locales/bs.yml                         |  18 +
 config/locales/ca.yml                         |  20 +
 config/locales/cs.yml                         |  20 +
 config/locales/da.yml                         |  20 +
 config/locales/de.yml                         |  20 +
 config/locales/el.yml                         |  20 +
 config/locales/en-GB.yml                      |  20 +
 config/locales/en.yml                         |  21 +
 config/locales/es-PA.yml                      |  20 +
 config/locales/es.yml                         |  20 +
 config/locales/et.yml                         |  20 +
 config/locales/eu.yml                         |  24 +
 config/locales/fa.yml                         |  20 +
 config/locales/fi.yml                         |  20 +
 config/locales/fr.yml                         |  20 +
 config/locales/gl.yml                         |  20 +
 config/locales/he.yml                         |  20 +
 config/locales/hr.yml                         |  20 +
 config/locales/hu.yml                         |  20 +
 config/locales/id.yml                         |  20 +
 config/locales/it.yml                         |  22 +
 config/locales/ja.yml                         |  21 +
 config/locales/ko.yml                         |  20 +
 config/locales/lt.yml                         |  20 +
 config/locales/lv.yml                         |  21 +
 config/locales/mk.yml                         |  20 +
 config/locales/mn.yml                         |  20 +
 config/locales/nl.yml                         |  20 +
 config/locales/no.yml                         |  20 +
 config/locales/pl.yml                         |  21 +
 config/locales/pt-BR.yml                      |  21 +
 config/locales/pt.yml                         |  21 +
 config/locales/ro.yml                         |  20 +
 config/locales/ru.yml                         |  20 +
 config/locales/sk.yml                         |  20 +
 config/locales/sl.yml                         |  20 +
 config/locales/sq.yml                         |  20 +
 config/locales/sr-YU.yml                      |  20 +
 config/locales/sr.yml                         |  20 +
 config/locales/sv.yml                         |  20 +
 config/locales/ta-IN.yml                      |  20 +
 config/locales/th.yml                         |  20 +
 config/locales/tr.yml                         |  18 +
 config/locales/uk.yml                         |  20 +
 config/locales/vi.yml                         |  20 +
 config/locales/zh-TW.yml                      |  20 +
 config/locales/zh.yml                         |  20 +
 lib/redmine/views/labelled_form_builder.rb    |  12 +
 lib/redmine/wiki_formatting.rb                |   8 +-
 .../wiki_formatting/common_mark/helper.rb     |  34 --
 lib/redmine/wiki_formatting/textile/helper.rb |  32 -
 test/helpers/application_helper_test.rb       |  33 +-
 test/integration/layout_test.rb               |   7 +-
 139 files changed, 2510 insertions(+), 2322 deletions(-)
 delete mode 100644 app/assets/javascripts/jstoolbar/common_mark.js
 delete mode 100644 app/assets/javascripts/jstoolbar/jstoolbar.js
 delete mode 100644 app/assets/javascripts/jstoolbar/lang/jstoolbar-ar.js
 delete mode 100644 app/assets/javascripts/jstoolbar/lang/jstoolbar-az.js
 delete mode 100644 app/assets/javascripts/jstoolbar/lang/jstoolbar-bg.js
 delete mode 100644 app/assets/javascripts/jstoolbar/lang/jstoolbar-bs.js
 delete mode 100644 app/assets/javascripts/jstoolbar/lang/jstoolbar-ca.js
 delete mode 100644 app/assets/javascripts/jstoolbar/lang/jstoolbar-cs.js
 delete mode 100644 app/assets/javascripts/jstoolbar/lang/jstoolbar-da.js
 delete mode 100644 app/assets/javascripts/jstoolbar/lang/jstoolbar-de.js
 delete mode 100644 app/assets/javascripts/jstoolbar/lang/jstoolbar-en-gb.js
 delete mode 100644 app/assets/javascripts/jstoolbar/lang/jstoolbar-en.js
 delete mode 100644 app/assets/javascripts/jstoolbar/lang/jstoolbar-es-pa.js
 delete mode 100644 app/assets/javascripts/jstoolbar/lang/jstoolbar-es.js
 delete mode 100644 app/assets/javascripts/jstoolbar/lang/jstoolbar-et.js
 delete mode 100644 app/assets/javascripts/jstoolbar/lang/jstoolbar-eu.js
 delete mode 100644 app/assets/javascripts/jstoolbar/lang/jstoolbar-fa.js
 delete mode 100644 app/assets/javascripts/jstoolbar/lang/jstoolbar-fi.js
 delete mode 100644 app/assets/javascripts/jstoolbar/lang/jstoolbar-fr.js
 delete mode 100644 app/assets/javascripts/jstoolbar/lang/jstoolbar-gl.js
 delete mode 100644 app/assets/javascripts/jstoolbar/lang/jstoolbar-he.js
 delete mode 100644 app/assets/javascripts/jstoolbar/lang/jstoolbar-hr.js
 delete mode 100644 app/assets/javascripts/jstoolbar/lang/jstoolbar-hu.js
 delete mode 100644 app/assets/javascripts/jstoolbar/lang/jstoolbar-id.js
 delete mode 100644 app/assets/javascripts/jstoolbar/lang/jstoolbar-it.js
 delete mode 100644 app/assets/javascripts/jstoolbar/lang/jstoolbar-ja.js
 delete mode 100644 app/assets/javascripts/jstoolbar/lang/jstoolbar-ko.js
 delete mode 100644 app/assets/javascripts/jstoolbar/lang/jstoolbar-lt.js
 delete mode 100644 app/assets/javascripts/jstoolbar/lang/jstoolbar-lv.js
 delete mode 100644 app/assets/javascripts/jstoolbar/lang/jstoolbar-mk.js
 delete mode 100644 app/assets/javascripts/jstoolbar/lang/jstoolbar-mn.js
 delete mode 100644 app/assets/javascripts/jstoolbar/lang/jstoolbar-nl.js
 delete mode 100644 app/assets/javascripts/jstoolbar/lang/jstoolbar-no.js
 delete mode 100644 app/assets/javascripts/jstoolbar/lang/jstoolbar-pl.js
 delete mode 100644 app/assets/javascripts/jstoolbar/lang/jstoolbar-pt.js
 delete mode 100644 app/assets/javascripts/jstoolbar/lang/jstoolbar-ro.js
 delete mode 100644 app/assets/javascripts/jstoolbar/lang/jstoolbar-ru.js
 delete mode 100644 app/assets/javascripts/jstoolbar/lang/jstoolbar-sk.js
 delete mode 100644 app/assets/javascripts/jstoolbar/lang/jstoolbar-sl.js
 delete mode 100644 app/assets/javascripts/jstoolbar/lang/jstoolbar-sq.js
 delete mode 100644 app/assets/javascripts/jstoolbar/lang/jstoolbar-sr-yu.js
 delete mode 100644 app/assets/javascripts/jstoolbar/lang/jstoolbar-sr.js
 delete mode 100644 app/assets/javascripts/jstoolbar/lang/jstoolbar-sv.js
 delete mode 100644 app/assets/javascripts/jstoolbar/lang/jstoolbar-ta-in.js
 delete mode 100644 app/assets/javascripts/jstoolbar/lang/jstoolbar-th.js
 delete mode 100644 app/assets/javascripts/jstoolbar/lang/jstoolbar-tr.js
 delete mode 100644 app/assets/javascripts/jstoolbar/lang/jstoolbar-uk.js
 delete mode 100644 app/assets/javascripts/jstoolbar/lang/jstoolbar-vi.js
 delete mode 100644 app/assets/javascripts/jstoolbar/lang/jstoolbar-zh-tw.js
 delete mode 100644 app/assets/javascripts/jstoolbar/lang/jstoolbar-zh.js
 delete mode 100644 app/assets/javascripts/jstoolbar/textile.js
 delete mode 100644 app/javascript/controllers/list_autofill_controller.js
 create mode 100644 app/javascript/controllers/precode_controller.js
 create mode 100644 app/javascript/controllers/table_generator_controller.js
 create mode 100644 app/javascript/controllers/template_controller.js
 create mode 100644 app/javascript/controllers/texteditor_controller.js
 create mode 100644 app/javascript/helper.js
 create mode 100644 app/javascript/jstoolbar.js
 create mode 100644 app/javascript/jstoolbar/formatting/common_mark.js
 create mode 100644 app/javascript/jstoolbar/formatting/textile.js
 create mode 100644 app/views/common/_code_highlighting.html.erb
 create mode 100644 app/views/common/_table_generator.html.erb
 create mode 100644 app/views/common/_texteditor.html.erb

diff --git a/app/helpers/application_helper.rb b/app/helpers/application_helper.rb
index e64eb3616..28b5a85fb 100644
--- a/app/helpers/application_helper.rb
+++ b/app/helpers/application_helper.rb
@@ -30,9 +30,6 @@ module ApplicationHelper
   include Redmine::Helpers::URL
   include IconsHelper
 
-  extend Forwardable
-  def_delegators :wiki_helper, :wikitoolbar_for, :heads_for_wiki_formatter
-
   # Return true if user is authorized for controller/action, otherwise false
   def authorize_for(controller, action)
     User.current.allowed_to?({:controller => controller, :action => action}, @project)
@@ -1438,16 +1435,6 @@ module ApplicationHelper
     end
   end
 
-  def list_autofill_data_attributes
-    return {} if Setting.text_formatting.blank?
-
-    {
-      controller: 'list-autofill',
-      action: 'beforeinput->list-autofill#handleBeforeInput',
-      list_autofill_text_formatting_param: Setting.text_formatting
-    }
-  end
-
   unless const_defined?(:MACROS_RE)
     MACROS_RE = /(
                   (!)?                        # escaping
@@ -1960,6 +1947,48 @@ module ApplicationHelper
     )
   end
 
+  def add_wiki_toolbar(data, &)
+    heads_for_wiki_formatter
+
+    preview_url = data.delete(:wiki_preview_url) || preview_text_path
+    data[:texteditor_target] = 'editor'
+    data[:action] = 'click->texteditor#shortcut beforeinput->texteditor#autofillListItem'
+
+    render layout: 'common/texteditor', locals: {preview_url: preview_url}, formats: [:html], &
+  end
+
+  def heads_for_wiki_formatter
+    unless @heads_for_wiki_formatter_included
+      toolbar_language_options = User.current && User.current.pref.toolbar_language_options
+      langs = if toolbar_language_options.nil?
+                UserPreference::DEFAULT_TOOLBAR_LANGUAGE_OPTIONS
+              else
+                toolbar_language_options.split(',')
+              end
+      content_for :header_tags do
+        javascript_tag(
+          "var wikiImageMimeTypes = #{Redmine::MimeType.by_type('image').to_json};") +
+        tag.script(raw(l(:jstoolbar).to_json), type: 'application/json', id: 'jstoolbar-locale') +
+        stylesheet_link_tag('jstoolbar') +
+        render(partial: 'common/table_generator') +
+        render(partial: 'common/code_highlighting', locals: {langs: langs})
+      end
+      @heads_for_wiki_formatter_included = true
+    end
+  end
+
+  def text_area_tag(name, content, options={})
+    data = options[:data] || {}
+    wiki_toolbar = data.delete(:wiki_toolbar)
+    if wiki_toolbar
+      add_wiki_toolbar(data) do
+        text_area_tag(name, content, options)
+      end
+    else
+      super
+    end
+  end
+
   private
 
   def wiki_helper
diff --git a/app/helpers/custom_fields_helper.rb b/app/helpers/custom_fields_helper.rb
index 14025b934..d20686e71 100644
--- a/app/helpers/custom_fields_helper.rb
+++ b/app/helpers/custom_fields_helper.rb
@@ -77,17 +77,16 @@ module CustomFieldsHelper
   end
 
   # Return custom field html tag corresponding to its format
-  def custom_field_tag(prefix, custom_value)
+  def custom_field_tag(prefix, custom_value, data = {})
     cf = custom_value.custom_field
     css = cf.css_classes
     placeholder = cf.description
     placeholder&.tr!("\n", ' ') if cf.field_format != 'text'
-    data = nil
     if cf.full_text_formatting?
       css += ' wiki-edit'
       data = {
         :auto_complete => true
-      }.merge(list_autofill_data_attributes)
+      }
     end
     cf.format.edit_tag(
       self,
@@ -120,7 +119,8 @@ module CustomFieldsHelper
 
   # Return custom field tag with its label tag
   def custom_field_tag_with_label(name, custom_value, options={})
-    tag = custom_field_tag(name, custom_value)
+    data = options.delete(:data) || {}
+    tag = custom_field_tag(name, custom_value, data)
     tag_id = nil
     ids = tag.scan(/ id="(.+?)"/)
     if ids.size == 1
@@ -130,14 +130,14 @@ module CustomFieldsHelper
   end
 
   # Returns the custom field tag for when bulk editing objects
-  def custom_field_tag_for_bulk_edit(prefix, custom_field, objects=nil, value='')
+  def custom_field_tag_for_bulk_edit(prefix, custom_field, objects=nil, value='', options={})
     css =  custom_field.css_classes
-    data = nil
+    data = options.delete(:data) || {}
     if custom_field.full_text_formatting?
       css += ' wiki-edit'
       data = {
         :auto_complete => true
-      }.merge(list_autofill_data_attributes)
+      }
     end
     custom_field.format.bulk_edit_tag(
       self,
diff --git a/app/javascript/controllers/precode_controller.js b/app/javascript/controllers/precode_controller.js
new file mode 100644
index 000000000..406318bb6
--- /dev/null
+++ b/app/javascript/controllers/precode_controller.js
@@ -0,0 +1,52 @@
+/**
+ * Redmine - project management software
+ * Copyright (C) 2006-  Jean-Philippe Lang
+ * This code is released under the GNU General Public License.
+ */
+
+import { Controller } from "@hotwired/stimulus"
+
+// Connects to data-controller="precode"
+export default class extends Controller {
+  connect() {
+    this.currentElem = null;
+  }
+
+  select(e) {
+    if (this.currentElem) return;
+
+    let target = event.target.closest('.jst_menuitem');
+    if (!target || !this.element.contains(target)) return;
+
+    this.currentElem = target;
+    target.classList.add('jst_menuitem-active')
+  }
+
+  unselect(e) {
+    if (!this.currentElem) return;
+
+    let relatedTarget = event.relatedTarget;
+    if (relatedTarget) {
+      while (relatedTarget) {
+        if (relatedTarget == this.currentElem) return;
+        relatedTarget = relatedTarget.parentNode;
+      }
+    }
+    this.currentElem.classList.remove('jst_menuitem-active')
+    this.currentElem = null;
+  }
+
+  addMenu(e) {
+    this.element.addMenu(e.target.textContent)
+  }
+
+  remove(e) {
+    this.element.remove();
+  }
+
+  removeWhenOutside(e) {
+    if (!e.target.matches('.jstb_precode') && !this.element.contains(e.target)) {
+      this.remove();
+    }
+  }
+}
diff --git a/app/javascript/controllers/table_generator_controller.js b/app/javascript/controllers/table_generator_controller.js
new file mode 100644
index 000000000..9b50e2da1
--- /dev/null
+++ b/app/javascript/controllers/table_generator_controller.js
@@ -0,0 +1,41 @@
+/**
+ * Redmine - project management software
+ * Copyright (C) 2006-  Jean-Philippe Lang
+ * This code is released under the GNU General Public License.
+ */
+
+import { Controller } from "@hotwired/stimulus"
+
+// Connects to data-controller="table-generator"
+export default class extends Controller {
+
+  addMenu(e) {
+    const row = parseInt(e.target.dataset.row);
+    const col = parseInt(e.target.dataset.col);
+    const alphabets = this.element.dataset.alphabets.split('');
+    this.element.addMenu(alphabets.slice(0, col), row);
+  }
+
+  selectCell(e) {
+    const hoverRow = parseInt(e.target.dataset.row);
+    const hoverCol = parseInt(e.target.dataset.col);
+
+    e.currentTarget.querySelectorAll('td').forEach(element => {
+      if (parseInt(element.dataset.row) <= hoverRow && parseInt(element.dataset.col) <= hoverCol) {
+        element.classList.add('selected-cell');
+      } else {
+        element.classList.remove('selected-cell');
+      }
+    })
+  }
+
+  remove(e) {
+    this.element.remove();
+  }
+
+  removeWhenOutside(e) {
+    if (!e.target.matches('.jstb_table') && !this.element.contains(e.target)) {
+      this.remove();
+    }
+  }
+}
diff --git a/app/javascript/controllers/template_controller.js b/app/javascript/controllers/template_controller.js
new file mode 100644
index 000000000..89033d92d
--- /dev/null
+++ b/app/javascript/controllers/template_controller.js
@@ -0,0 +1,18 @@
+/**
+ * Redmine - project management software
+ * Copyright (C) 2006-  Jean-Philippe Lang
+ * This code is released under the GNU General Public License.
+ */
+
+import { Controller } from "@hotwired/stimulus"
+
+// Connects to data-controller="template"
+export default class extends Controller {
+  static targets = ['element']
+
+  elementTargetConnected(element) {
+    const clone = element.content.cloneNode(true);
+    this.element.prepend(clone);
+    element.remove()
+  }
+}
diff --git a/app/javascript/controllers/texteditor_controller.js b/app/javascript/controllers/texteditor_controller.js
new file mode 100644
index 000000000..7d80abf10
--- /dev/null
+++ b/app/javascript/controllers/texteditor_controller.js
@@ -0,0 +1,84 @@
+/**
+ * Redmine - project management software
+ * Copyright (C) 2006-  Jean-Philippe Lang
+ * This code is released under the GNU General Public License.
+ */
+
+import { Controller } from "@hotwired/stimulus"
+import { post } from '@rails/request.js'
+import { jsonContent } from 'helper'
+
+// Connects to data-controller="texteditor"
+export default class extends Controller {
+
+  static targets = ['editor', 'tabs', 'edittab', 'previewtab', 'elements', 'main', 'preview' ]
+  static values  = { 'previewUrl': String }
+
+  connect() {
+    const lang = jsonContent('jstoolbar-locale')
+
+    Promise.all([
+      import('jstoolbar'),
+      import(`jstoolbar/formatting/${this.element.dataset.formatting}`)
+    ])
+      .then(([mod, formatting]) => {
+         const { default: jsToolBar } = mod;
+         jsToolBar.strings = lang;
+         this.toolbar = new jsToolBar(this, formatting.default)
+         this.toolbar.setHelpLink(this.element.dataset.help)
+         this.toolbar.draw()
+     })
+  }
+
+  preview(e) {
+    e.preventDefault()
+    e.stopPropagation()
+
+    const data = { text: this.editorTarget.value };
+
+    const form = e.target.closest('form');
+    form.querySelectorAll('.attachments_fields input').forEach(el => (data[el.name] = el.value))
+
+    post(this.previewUrlValue, {
+      body: data
+    }).then(res => {
+      if (res.ok) {
+        return res.html
+      }
+    }).then(html => {
+      this.previewTarget.innerHTML = html;
+      setupWikiTableSortableHeader();
+    });
+  }
+
+  shortcut(e) {
+    e.preventDefault()
+    this.toolbar.keyboardShortcuts.call(this.toolbar, e);
+  }
+
+  hidePreview(e) {
+    e.preventDefault()
+    this.toolbar.hidePreview.call(this.toolbar, e);
+  }
+
+  showPreview(e) {
+    e.preventDefault()
+    this.toolbar.showPreview.call(this.toolbar, e);
+  }
+
+  keyboardShortcuts(e) {
+    this.toolbar.keyboardShortcuts.call(this.toolbar, e);
+  }
+
+  togglePreview(e) {
+    this.toolbar.togglePreview(e);
+  }
+
+  autofillListItem(e) {
+    this.toolbar.autofillListItem(e)
+  }
+
+  execute(e) {
+    this.toolbar.execute.call(this.toolbar, e);
+  }
+}
diff --git a/app/javascript/helper.js b/app/javascript/helper.js
new file mode 100644
index 000000000..945ccdb38
--- /dev/null
+++ b/app/javascript/helper.js
@@ -0,0 +1,17 @@
+/**
+ * Redmine - project management software
+ * Copyright (C) 2006-  Jean-Philippe Lang
+ * This code is released under the GNU General Public License.
+ */
+
+export function jsonContent(id) {
+  const json = document.getElementById(id);
+  if (json === null) throw new Error(`Element #${id} is not found`)
+  if (!(json.tagName === 'SCRIPT' && json.getAttribute('type', 'application/json'))) throw new Error(`Element #${id} should be script element`)
+
+  return JSON.parse(json.textContent)
+}
+
+export function isMac() {
+  return Boolean(navigator.platform.toLowerCase().match(/mac/));
+}
